/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.mojo;

import java.io.File;
import java.util.List;

import jp.objectfanatics.assertion.constraints.NotNull;

import org.apache.maven.plugin.MojoExecutionException;

/**
 * reference
 * <ul>
 *   <li>http://maven.apache.org/plugin-developers/index.html
 *   <li>http://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html
 * </ul>
 * 
 * @author Makoto Sato
 * @phase compile
 * @goal main-weave
 */
public class MainWeavingMojo extends AbstractWeavingMojo {
	
	/**
	 * ${project.compileClasspathElements}
	 * 
	 * @parameter expression="${project.compileClasspathElements}"
	 */
	protected List<String> compileClasspathElements;
	
	/**
	 * ${project.compileSourceRoots}
	 * 
	 * @parameter expression="${project.compileSourceRoots}"
	 */
	protected List<String> compileSourceRoots;
	
	@Override
	public void execute() throws MojoExecutionException {
		path = buildDirectory + File.separator + "classes";
		if (compileSourceRoots.size() == 1) sourceRoot = compileSourceRoots.get(0);
		super.execute();
	}
	
	@Override
	@NotNull
	protected List<String> getClasspaths() {
		return compileClasspathElements;
	}
}
