/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.mojo;

import java.io.File;
import java.util.List;

import jp.objectfanatics.assertion.constraints.NotNull;

import org.apache.maven.plugin.MojoExecutionException;

/**
 * @author Makoto Sato
 *
 * @phase test-compile
 * @goal test-weave
 */
public class TestWeavingMojo extends AbstractWeavingMojo {
	
	/**
	 * ${project.testClasspathElements}
	 * 
	 * @parameter expression="${project.testClasspathElements}"
	 */
	private List<String> testClasspathElements;
	
	/**
	 * ${project.testCompileSourceRoots}
	 * 
	 * @parameter expression="${project.testCompileSourceRoots}"
	 */
	protected List<String> testCompileSourceRoots;
	
	@Override
	public void execute() throws MojoExecutionException {
		path = buildDirectory + File.separator + "test-classes";
		if (testCompileSourceRoots.size() == 1) sourceRoot = testCompileSourceRoots.get(0);
		super.execute();
	}
	
	@Override
	@NotNull
	protected List<String> getClasspaths() {
		return testClasspathElements;
	}
}
